import{s as ki,n as Di,o as Hi}from"../chunks/scheduler.048ce5c2.js";import{S as Ii,i as Pi,g as l,s as o,r as f,A as Ei,h as s,f as i,c as a,j as $i,u as h,x as r,k as _i,y as Ai,a as n,v as d,d as u,t as m,w as p}from"../chunks/index.2633050f.js";import{H as g,E as Si}from"../chunks/EditOnGithub.336973dd.js";function Gi(Pt){let c,ye,Me,Le,v,$e,w,Et="Welcome to Unit 4 of the Hugging Face Diffusion Models Course! In this unit, we will look at some of the many improvements and extensions to diffusion models appearing in the latest research. It will be less code-heavy than previous units have been and is designed to give you a jumping-off point for further research.",_e,b,ke,x,At="Here are the steps for this unit:",De,T,St='<li>Make sure you’ve <a href="https://huggingface.us17.list-manage.com/subscribe?u=7f57e683fa28b51bfc493d048&amp;id=ef963b4162" rel="nofollow">signed up for this course</a> so that you can be notified when additional units are added to the course.</li> <li>Read through the material below for an overview of the different topics covered in this unit.</li> <li>Dive deeper into any specific topics with the linked videos and resources.</li> <li>Explore the demo notebooks and then read the ‘What Next’ section for some project suggestions.</li>',He,M,Gt=':loudspeaker: Don’t forget to join <a href="https://huggingface.co/join/discord" rel="nofollow">Discord</a>, where you can discuss the material and share what you’ve made in the <code>#diffusion-models-class</code> channel.',Ie,C,Pe,y,Nt='<li><a href="#unit-4-going-further-with-diffusion-models">Unit 4: Going Further with Diffusion Models</a><ul><li><a href="#start-this-unit-rocket">Start this Unit :rocket:</a></li> <li><a href="#table-of-contents">Table of Contents</a></li> <li><a href="#faster-sampling-via-distillation">Faster Sampling via Distillation</a></li> <li><a href="#training-improvements">Training Improvements</a></li> <li><a href="#more-control-for-generation-and-editing">More Control for Generation and Editing</a></li> <li><a href="#video">Video</a></li> <li><a href="#audio">Audio</a></li> <li><a href="#new-architectures-and-approaches---towards-iterative-refinement">New Architectures and Approaches - Towards ‘Iterative Refinement’</a></li> <li><a href="#hands-on-notebooks">Hands-On Notebooks</a></li> <li><a href="#where-next">Where Next?</a></li></ul></li>',Ee,L,Ae,$,Ut='Progressive distillation is a technique for taking an existing diffusion model and using it to train a new version of the model that requires fewer steps for inference. The ‘student’ model is initialized from the weights of the ‘teacher’ model. During training, the teacher model performs two sampling steps and the student model tries to match the resulting prediction in a single step. This process can be repeated multiple times, with the previous iteration’s student model becoming the teacher for the next stage. The result is a model that can produce decent samples in much fewer steps (typically 4 or 8) than the original teacher model. The core mechanism is illustrated in this diagram from the <a href="http://arxiv.org/abs/2202.00512" rel="nofollow">paper that introduced the idea</a>:',Se,_,qt='<img src="https://user-images.githubusercontent.com/6575163/211016659-7dac24a5-37e2-45f9-aba8-0c573937e7fb.png" alt="image"/>',Ge,k,Ot='<em>Progressive Distillation illustrated (from the <a href="http://arxiv.org/abs/2202.00512" rel="nofollow">paper</a>)</em>',Ne,D,Rt='The idea of using an existing model to ‘teach’ a new model can be extended to create guided models where the classifier-free guidance technique is used by the teacher model and the student model must learn to produce an equivalent output in a single step based on an additional input specifying the targeted guidance scale. This further reduces the number of model evaluations required to produce high-quality samples. <a href="https://www.youtube.com/watch?v=ZXuK6IRJlnk" rel="nofollow">This video</a> gives an overview of the approach.',Ue,H,Ft='NB: A distilled version of Stable Diffusion can be used <a href="https://huggingface.co/docs/diffusers/main/en/using-diffusers/distilled_sd" rel="nofollow">here</a>.',qe,I,jt="Key references:",Oe,P,Vt='<li><a href="http://arxiv.org/abs/2202.00512" rel="nofollow">Progressive Distillation For Fast Sampling Of Diffusion Models</a></li> <li><a href="http://arxiv.org/abs/2210.03142" rel="nofollow">On Distillation Of Guided Diffusion Models</a></li>',Re,E,Fe,A,Wt="There have been several additional tricks developed to improve diffusion model training. In this section we’ve tried to capture the core ideas from recent papers. There is a constant stream of research coming out with additional improvements, so if you see a paper you feel should be added here please let us know!",je,S,Kt='<img src="https://user-images.githubusercontent.com/6575163/211021220-e87ca296-cf15-4262-9359-7aeffeecbaae.png" alt="image"/> <em>Figure 2 from the <a href="http://arxiv.org/abs/2210.15257" rel="nofollow">ERNIE-ViLG 2.0 paper</a></em>',Ve,G,zt="Key training improvements:",We,N,Bt='<li>Tuning the noise schedule, loss weighting and sampling trajectories for more efficient training. An excellent paper exploring some of these design choices is <a href="http://arxiv.org/abs/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> by Karras et al.</li> <li>Training on diverse aspect ratios, as described in <a href="https://www.youtube.com/watch?v=g6tIUrMvOec" rel="nofollow">this video from the course launch event</a>.</li> <li>Cascaded diffusion models, training one model at low resolution and then one or more super-res models. Used in DALLE-2, Imagen and more for high-resolution image generation.</li> <li>Better conditioning, incorporating rich text embeddings (<a href="https://arxiv.org/abs/2205.11487" rel="nofollow">Imagen</a> uses a large language model called T5) or multiple types of conditioning (<a href="http://arxiv.org/abs/2211.01324" rel="nofollow">eDiffi</a>).</li> <li>‘Knowledge Enhancement’ - incorporating pre-trained image captioning and object detection models into the training process to create more informative captions and produce better performance (<a href="http://arxiv.org/abs/2210.15257" rel="nofollow">ERNIE-ViLG 2.0</a>).</li> <li>‘Mixture of Denoising Experts’ (MoDE) - training different variants of the model (‘experts’) for different noise levels as illustrated in the image above from the <a href="http://arxiv.org/abs/2210.15257" rel="nofollow">ERNIE-ViLG 2.0 paper</a>.</li>',Ke,U,Jt="Key references:",ze,q,Qt='<li><a href="http://arxiv.org/abs/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a></li> <li><a href="http://arxiv.org/abs/2211.01324" rel="nofollow">eDiffi: Text-to-Image Diffusion Models with an Ensemble of Expert Denoisers</a></li> <li><a href="http://arxiv.org/abs/2210.15257" rel="nofollow">ERNIE-ViLG 2.0: Improving Text-to-Image Diffusion Model with Knowledge-Enhanced Mixture-of-Denoising-Experts</a></li> <li><a href="https://arxiv.org/abs/2205.11487" rel="nofollow">Imagen - Photorealistic Text-to-Image Diffusion Models with Deep Language Understanding</a> (<a href="https://imagen.research.google/" rel="nofollow">demo site</a>)</li>',Be,O,Je,R,Xt="In addition to training improvements, there have been several innovations in the sampling and inference phase, including many approaches that can add new capabilities to existing diffusion models.",Qe,F,Zt='<img src="https://user-images.githubusercontent.com/6575163/212529129-3de41cf4-6f70-4607-8448-e9bbe9d190cf.png" alt="image"/> <em>Samples generated by ‘paint-with-words’ (<a href="http://arxiv.org/abs/2211.01324" rel="nofollow">eDiffi</a>)</em>',Xe,j,Yt='The video <a href="https://www.youtube.com/watch?v=zcG7tG3xS3s" rel="nofollow">‘Editing Images with Diffusion Models’</a> gives an overview of the different methods being used to edit existing images with diffusion models. The available techniques can be split into four main categories:',Ze,V,ei="1) Add noise and then denoise with a new prompt. This is the idea behind the <code>img2img</code> pipeline, which has been modified and extended in various papers:",Ye,W,ti=`<li><a href="https://sde-image-editing.github.io/" rel="nofollow">SDEdit</a> and <a href="https://magicmix.github.io/" rel="nofollow">MagicMix</a> build on this idea.</li> <li>DDIM inversion (TODO link tutorial) uses the model to ‘reverse’ the sampling trajectory rather than adding random noise, giving more control.</li> <li><a href="https://null-text-inversion.github.io/" rel="nofollow">Null-text Inversion</a> enhances the performance of this kind of approach dramatically by optimizing the unconditional text embeddings used for classifier-free guidance at each step, allowing for extremely high-quality text-based image editing.
2) Extending the ideas in (1) but with a mask to control where the effect is applied:</li> <li><a href="https://omriavrahami.com/blended-diffusion-page/" rel="nofollow">Blended Diffusion</a> introduces the basic idea.</li> <li><a href="https://huggingface.co/spaces/nielsr/text-based-inpainting" rel="nofollow">This demo</a> uses an existing segmentation model (CLIPSeg) to create the mask based on a text description.</li> <li><a href="https://arxiv.org/abs/2210.11427" rel="nofollow">DiffEdit</a> is an excellent paper that shows how the diffusion model itself can be used to generate an appropriate mask for editing the image based on text.</li> <li><a href="https://arxiv.org/abs/2212.05034" rel="nofollow">SmartBrush: Text and Shape Guided Object Inpainting with Diffusion Model</a> fine-tunes a diffusion model for more accurate mask-guided inpainting.
3) Cross-attention Control: using the cross-attention mechanism in diffusion models to control the spatial location of edits for more fine-grained control:</li> <li><a href="https://arxiv.org/abs/2208.01626" rel="nofollow">Prompt-to-Prompt Image Editing with Cross Attention Control</a> is the key paper that introduced this idea, and the technique has <a href="https://wandb.ai/wandb/cross-attention-control/reports/Improving-Generative-Images-with-Instructions-Prompt-to-Prompt-Image-Editing-with-Cross-Attention-Control--VmlldzoyNjk2MDAy" rel="nofollow">since been applied to Stable Diffusion</a>.</li> <li>This idea is also used for ‘paint-with-words’ (<a href="http://arxiv.org/abs/2211.01324" rel="nofollow">eDiffi</a>, shown above).
4) Fine-tune (‘overfit’) on a single image and then generate with the fine-tuned model. The following papers both published variants of this idea at roughly the same time:</li> <li><a href="https://arxiv.org/abs/2210.09276" rel="nofollow">Imagic: Text-Based Real Image Editing with Diffusion Models</a>.</li> <li><a href="https://arxiv.org/abs/2210.09477" rel="nofollow">UniTune: Text-Driven Image Editing by Fine Tuning an Image Generation Model on a Single Image
</a>.</li>`,et,K,ii='The paper <a href="https://arxiv.org/abs/2211.09800" rel="nofollow">InstructPix2Pix: Learning to Follow Image Editing Instructions</a> is notable in that it used some of the image editing techniques described above to build a synthetic dataset of image pairs alongside image edit instructions (generated with GPT3.5) to train a new model capable of editing images based on natural language instructions.',tt,z,it,B,ni='<img src="https://user-images.githubusercontent.com/6575163/213657523-be40178a-4357-410b-89e3-a4cbd8528900.png" alt="image"/> <em>Still frames from <a href="https://imagen.research.google/video/" rel="nofollow">sample videos generated with Imagen Video</a></em>',nt,J,oi="A video can be represented as a sequence of images, and the core ideas of diffusion models can be applied to these sequences. Recent work has focused on finding appropriate architectures (such as ‘3D UNets’ which operate on entire sequences) and on working efficiently with video data. Since high-frame-rate video involves a lot more data than still images, current approaches tend to first generate low-resolution and low-frame-rate video and then apply spatial and temporal super-resolution to produce the final high-quality video outputs.",ot,Q,ai="Key references:",at,X,li='<li><a href="https://video-diffusion.github.io/" rel="nofollow">Video Diffusion Models</a></li> <li><a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">IMAGEN VIDEO: HIGH DEFINITION VIDEO GENERATION WITH DIFFUSION MODELS</a></li>',lt,Z,st,Y,si='<img src="https://user-images.githubusercontent.com/6575163/213657272-a1b54017-216f-453b-9b28-97c6fef21f54.png" alt="image"/>',rt,ee,ri='<em>A spectrogram generated with Riffusion (<a href="https://www.riffusion.com/about" rel="nofollow">image source</a>)</em>',ft,te,fi='While there has been some work on generating audio directly using diffusion models (e.g. <a href="https://arxiv.org/abs/2009.09761" rel="nofollow">DiffWave</a>) the most successful approach so far has been to convert the audio signal into something called a spectrogram, which effectively ‘encodes’ the audio as a 2D “image” which can then be used to train the kinds of diffusion models we’re used to using for image generation. The resulting generated spectrograms can then be converted into audio using existing methods. This approach is behind the recently-released Riffusion, which fine-tuned Stable Diffusion to generate spectrograms conditioned on text - <a href="https://www.riffusion.com/" rel="nofollow">try it out here</a>.',ht,ie,hi="The field of audio generation is moving extremely quickly. Over the past week (at the time of writing) there have been at least 5 new advances announced, which are marked with a star in the list below:",dt,ne,di="Key references:",ut,oe,ui='<li><a href="https://arxiv.org/abs/2009.09761" rel="nofollow">DiffWave: A Versatile Diffusion Model for Audio Synthesis</a></li> <li><a href="https://www.riffusion.com/about" rel="nofollow">‘Riffusion’</a> (and <a href="https://github.com/riffusion/riffusion" rel="nofollow">code</a>)</li> <li>*<a href="https://google-research.github.io/seanet/musiclm/examples/" rel="nofollow">MusicLM</a> by Google generates consistent audio from text and can be conditioned with hummed or whistled melodies.</li> <li><em><a href="https://github.com/acids-ircam/RAVE" rel="nofollow">RAVE2</a> - A new version of a Variational Auto-Encoder that will be useful for latent diffusion on audio tasks. This is used in the soon-to-be-announced </em><a href="https://twitter.com/LiuHaohe/status/1619119637660327936?s=20&amp;t=jMkPWBFuAH19HI9m5Sklmg" rel="nofollow">AudioLDM</a> model.</li> <li>*<a href="https://noise2music.github.io/" rel="nofollow">Noise2Music</a> - A diffusion model trained to produce high-quality 30-second clips of audio based on text descriptions.</li> <li>*<a href="https://text-to-audio.github.io/" rel="nofollow">Make-An-Audio: Text-To-Audio Generation with Prompt-Enhanced Diffusion Models</a> - A diffusion model trained to generate diverse sounds based on text.</li> <li>*<a href="https://arxiv.org/abs/2301.11757" rel="nofollow">Moûsai: Text-to-Music Generation with Long-Context Latent Diffusion</a></li>',mt,ae,pt,le,mi='<img src="https://user-images.githubusercontent.com/6575163/213731066-0fbe38a7-233f-42be-99fc-38cea889c86b.png" alt="image"/>',gt,se,pi='<em>Figure 1 from the <a href="http://arxiv.org/abs/2208.09392" rel="nofollow">Cold Diffusion</a> paper</em>',ct,re,gi="We are slowly moving beyond the original narrow definition of “diffusion” models and towards a more general class of models that perform <strong>iterative refinement</strong>, where some form of corruption (like the addition of gaussian noise in the forward diffusion process) is gradually reversed to generate samples. The ‘Cold Diffusion’ paper demonstrated that many other types of corruption can be iteratively ‘undone’ to generate images (examples shown above), and recent transformer-based approaches have demonstrated the effectiveness of token replacement or masking as a noising strategy.",vt,fe,ci='<img src="https://user-images.githubusercontent.com/6575163/213731351-7fd6c98c-6ba6-4bd9-a898-230002fc334f.png" alt="image"/>',wt,he,vi='<em>Pipeline from <a href="http://arxiv.org/abs/2202.04200" rel="nofollow">MaskGIT</a></em>',bt,de,wi='The UNet architecture at the heart of many current diffusion models is also being replaced with different alternatives, most notably various transformer-based architectures. In <a href="https://www.wpeebles.com/DiT" rel="nofollow">Scalable Diffusion Models with Transformers (DiT)</a> a transformer is used in place of the UNet for a fairly standard diffusion model approach, with excellent results. <a href="https://arxiv.org/pdf/2212.11972.pdf" rel="nofollow">Recurrent Interface Networks</a> applies a novel transformer-based architecture and training strategy in pursuit of additional efficiency. <a href="http://arxiv.org/abs/2202.04200" rel="nofollow">MaskGIT</a> and <a href="http://arxiv.org/abs/2301.00704" rel="nofollow">MUSE</a> use transformer models to work with tokenized representations of images, although the <a href="https://arxiv.org/abs/2211.07292v1" rel="nofollow">Paella</a> model demonstrates that a UNet can also be applied successfully to these token-based regimes too.',xt,ue,bi="With each new paper, more efficient approaches are being developed, and it may be some time before we see what peak performance looks like on these kinds of iterative refinement tasks. There is much more still to explore!",Tt,me,xi="Key references",Mt,pe,Ti='<li><a href="http://arxiv.org/abs/2208.09392" rel="nofollow">Cold Diffusion: Inverting Arbitrary Image Transforms Without Noise</a></li> <li><a href="https://www.wpeebles.com/DiT" rel="nofollow">Scalable Diffusion Models with Transformers (DiT)</a></li> <li><a href="http://arxiv.org/abs/2202.04200" rel="nofollow">MaskGIT: Masked Generative Image Transformer</a></li> <li><a href="http://arxiv.org/abs/2301.00704" rel="nofollow">Muse: Text-To-Image Generation via Masked Generative Transformers</a></li> <li><a href="https://arxiv.org/abs/2211.07292v1" rel="nofollow">Fast Text-Conditional Discrete Denoising on Vector-Quantized Latent Spaces (Paella)</a></li> <li><a href="https://arxiv.org/pdf/2212.11972.pdf" rel="nofollow">Recurrent Interface Networks</a> - A promising new architecture that does well at generating high-resolution images without relying on latent diffusion or super-resolution. See also, <a href="https://arxiv.org/abs/2301.11093" rel="nofollow">simple diffusion: End-to-end diffusion for high-resolution images</a> which highlights the importance of the noise schedule for training at higher resolutions.</li>',Ct,ge,yt,ce,Mi='<thead><tr><th align="left">Chapter</th> <th align="left">Colab</th> <th align="left">Kaggle</th> <th align="left">Gradient</th> <th align="left">Studio Lab</th></tr></thead> <tbody><tr><td align="left">DDIM Inversion</td> <td align="left"><a href="https://colab.research.google.com/github/huggingface/diffusion-models-class/blob/main/unit4/01_ddim_inversion.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td> <td align="left"><a href="https://kaggle.com/kernels/welcome?src=https://github.com/huggingface/diffusion-models-class/blob/main/unit4/01_ddim_inversion.ipynb" rel="nofollow"><img src="https://kaggle.com/static/images/open-in-kaggle.svg" alt="Kaggle"/></a></td> <td align="left"><a href="https://console.paperspace.com/github/huggingface/diffusion-models-class/blob/main/unit4/01_ddim_inversion.ipynb" rel="nofollow"><img src="https://assets.paperspace.io/img/gradient-badge.svg" alt="Gradient"/></a></td> <td align="left"><a href="https://studiolab.sagemaker.aws/import/github/huggingface/diffusion-models-class/blob/main/unit4/01_ddim_inversion.ipynb" rel="nofollow"><img src="https://studiolab.sagemaker.aws/studiolab.svg" alt="Open In SageMaker Studio Lab"/></a></td></tr> <tr><td align="left">Diffusion for Audio</td> <td align="left"><a href="https://colab.research.google.com/github/huggingface/diffusion-models-class/blob/main/unit4/02_diffusion_for_audio.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td> <td align="left"><a href="https://kaggle.com/kernels/welcome?src=https://github.com/huggingface/diffusion-models-class/blob/main/unit4/02_diffusion_for_audio.ipynb" rel="nofollow"><img src="https://kaggle.com/static/images/open-in-kaggle.svg" alt="Kaggle"/></a></td> <td align="left"><a href="https://console.paperspace.com/github/huggingface/diffusion-models-class/blob/main/unit4/02_diffusion_for_audio.ipynb" rel="nofollow"><img src="https://assets.paperspace.io/img/gradient-badge.svg" alt="Gradient"/></a></td> <td align="left"><a href="https://studiolab.sagemaker.aws/import/github/huggingface/diffusion-models-class/blob/main/unit4/02_diffusion_for_audio.ipynb" rel="nofollow"><img src="https://studiolab.sagemaker.aws/studiolab.svg" alt="Open In SageMaker Studio Lab"/></a></td></tr></tbody>',Lt,ve,Ci="We’ve covered a LOT of different ideas in this unit, many of which deserve much more detailed follow-on lessons in the future. For now, you can choose two of the many topics via the hands-on notebooks we’ve prepared.",$t,we,yi="<li><strong>DDIM Inversion</strong> shows how a technique called inversion can be used to edit images using existing diffusion models.</li> <li><strong>Diffusion for Audio</strong> introduces the idea of spectrograms and shows a minimal example of fine-tuning an audio diffusion model on a specific genre of music.</li>",_t,be,kt,xe,Li='This is the final unit of this course for now, which means that what comes next is up to you! Remember that you can always ask questions and chat about your projects on the Hugging Face <a href="https://huggingface.co/join/discord" rel="nofollow">Discord</a>. We look forward to seeing what you create 🤗.',Dt,Te,Ht,Ce,It;return v=new g({props:{title:"Unit 4: Going Further with Diffusion Models",local:"unit-4-going-further-with-diffusion-models",headingTag:"h1"}}),b=new g({props:{title:"Start this Unit :rocket:",local:"start-this-unit-rocket",headingTag:"h2"}}),C=new g({props:{title:"Table of Contents",local:"table-of-contents",headingTag:"h2"}}),L=new g({props:{title:"Faster Sampling via Distillation",local:"faster-sampling-via-distillation",headingTag:"h2"}}),E=new g({props:{title:"Training Improvements",local:"training-improvements",headingTag:"h2"}}),O=new g({props:{title:"More Control for Generation and Editing",local:"more-control-for-generation-and-editing",headingTag:"h2"}}),z=new g({props:{title:"Video",local:"video",headingTag:"h2"}}),Z=new g({props:{title:"Audio",local:"audio",headingTag:"h2"}}),ae=new g({props:{title:"New Architectures and Approaches - Towards ‘Iterative Refinement’",local:"new-architectures-and-approaches---towards-iterative-refinement",headingTag:"h2"}}),ge=new g({props:{title:"Hands-On Notebooks",local:"hands-on-notebooks",headingTag:"h2"}}),be=new g({props:{title:"Where Next?",local:"where-next",headingTag:"h2"}}),Te=new Si({props:{source:"https://github.com/huggingface/diffusion-models-class/blob/main/unit4/README.md"}}),{c(){c=l("meta"),ye=o(),Me=l("p"),Le=o(),f(v.$$.fragment),$e=o(),w=l("p"),w.textContent=Et,_e=o(),f(b.$$.fragment),ke=o(),x=l("p"),x.textContent=At,De=o(),T=l("ul"),T.innerHTML=St,He=o(),M=l("p"),M.innerHTML=Gt,Ie=o(),f(C.$$.fragment),Pe=o(),y=l("ul"),y.innerHTML=Nt,Ee=o(),f(L.$$.fragment),Ae=o(),$=l("p"),$.innerHTML=Ut,Se=o(),_=l("p"),_.innerHTML=qt,Ge=o(),k=l("p"),k.innerHTML=Ot,Ne=o(),D=l("p"),D.innerHTML=Rt,Ue=o(),H=l("p"),H.innerHTML=Ft,qe=o(),I=l("p"),I.textContent=jt,Oe=o(),P=l("ul"),P.innerHTML=Vt,Re=o(),f(E.$$.fragment),Fe=o(),A=l("p"),A.textContent=Wt,je=o(),S=l("p"),S.innerHTML=Kt,Ve=o(),G=l("p"),G.textContent=zt,We=o(),N=l("ul"),N.innerHTML=Bt,Ke=o(),U=l("p"),U.textContent=Jt,ze=o(),q=l("ul"),q.innerHTML=Qt,Be=o(),f(O.$$.fragment),Je=o(),R=l("p"),R.textContent=Xt,Qe=o(),F=l("p"),F.innerHTML=Zt,Xe=o(),j=l("p"),j.innerHTML=Yt,Ze=o(),V=l("p"),V.innerHTML=ei,Ye=o(),W=l("ul"),W.innerHTML=ti,et=o(),K=l("p"),K.innerHTML=ii,tt=o(),f(z.$$.fragment),it=o(),B=l("p"),B.innerHTML=ni,nt=o(),J=l("p"),J.textContent=oi,ot=o(),Q=l("p"),Q.textContent=ai,at=o(),X=l("ul"),X.innerHTML=li,lt=o(),f(Z.$$.fragment),st=o(),Y=l("p"),Y.innerHTML=si,rt=o(),ee=l("p"),ee.innerHTML=ri,ft=o(),te=l("p"),te.innerHTML=fi,ht=o(),ie=l("p"),ie.textContent=hi,dt=o(),ne=l("p"),ne.textContent=di,ut=o(),oe=l("ul"),oe.innerHTML=ui,mt=o(),f(ae.$$.fragment),pt=o(),le=l("p"),le.innerHTML=mi,gt=o(),se=l("p"),se.innerHTML=pi,ct=o(),re=l("p"),re.innerHTML=gi,vt=o(),fe=l("p"),fe.innerHTML=ci,wt=o(),he=l("p"),he.innerHTML=vi,bt=o(),de=l("p"),de.innerHTML=wi,xt=o(),ue=l("p"),ue.textContent=bi,Tt=o(),me=l("p"),me.textContent=xi,Mt=o(),pe=l("ul"),pe.innerHTML=Ti,Ct=o(),f(ge.$$.fragment),yt=o(),ce=l("table"),ce.innerHTML=Mi,Lt=o(),ve=l("p"),ve.textContent=Ci,$t=o(),we=l("ul"),we.innerHTML=yi,_t=o(),f(be.$$.fragment),kt=o(),xe=l("p"),xe.innerHTML=Li,Dt=o(),f(Te.$$.fragment),Ht=o(),Ce=l("p"),this.h()},l(e){const t=Ei("svelte-u9bgzb",document.head);c=s(t,"META",{name:!0,content:!0}),t.forEach(i),ye=a(e),Me=s(e,"P",{}),$i(Me).forEach(i),Le=a(e),h(v.$$.fragment,e),$e=a(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1m4yime"&&(w.textContent=Et),_e=a(e),h(b.$$.fragment,e),ke=a(e),x=s(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1hcxnu9"&&(x.textContent=At),De=a(e),T=s(e,"UL",{"data-svelte-h":!0}),r(T)!=="svelte-1bghyu1"&&(T.innerHTML=St),He=a(e),M=s(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-jm6v4r"&&(M.innerHTML=Gt),Ie=a(e),h(C.$$.fragment,e),Pe=a(e),y=s(e,"UL",{"data-svelte-h":!0}),r(y)!=="svelte-1y1jfir"&&(y.innerHTML=Nt),Ee=a(e),h(L.$$.fragment,e),Ae=a(e),$=s(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-rr501t"&&($.innerHTML=Ut),Se=a(e),_=s(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-19d253l"&&(_.innerHTML=qt),Ge=a(e),k=s(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-18as4ue"&&(k.innerHTML=Ot),Ne=a(e),D=s(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-imorwd"&&(D.innerHTML=Rt),Ue=a(e),H=s(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-e5vd18"&&(H.innerHTML=Ft),qe=a(e),I=s(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-yg7e4b"&&(I.textContent=jt),Oe=a(e),P=s(e,"UL",{"data-svelte-h":!0}),r(P)!=="svelte-1yt3ee9"&&(P.innerHTML=Vt),Re=a(e),h(E.$$.fragment,e),Fe=a(e),A=s(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-9npwgh"&&(A.textContent=Wt),je=a(e),S=s(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-ep8x6p"&&(S.innerHTML=Kt),Ve=a(e),G=s(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-q9peze"&&(G.textContent=zt),We=a(e),N=s(e,"UL",{"data-svelte-h":!0}),r(N)!=="svelte-uze9z"&&(N.innerHTML=Bt),Ke=a(e),U=s(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-yg7e4b"&&(U.textContent=Jt),ze=a(e),q=s(e,"UL",{"data-svelte-h":!0}),r(q)!=="svelte-ho0q3i"&&(q.innerHTML=Qt),Be=a(e),h(O.$$.fragment,e),Je=a(e),R=s(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-1so9xgk"&&(R.textContent=Xt),Qe=a(e),F=s(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-15hmm9e"&&(F.innerHTML=Zt),Xe=a(e),j=s(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1u57urq"&&(j.innerHTML=Yt),Ze=a(e),V=s(e,"P",{"data-svelte-h":!0}),r(V)!=="svelte-a2ar22"&&(V.innerHTML=ei),Ye=a(e),W=s(e,"UL",{"data-svelte-h":!0}),r(W)!=="svelte-ectw3b"&&(W.innerHTML=ti),et=a(e),K=s(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-1qx95vo"&&(K.innerHTML=ii),tt=a(e),h(z.$$.fragment,e),it=a(e),B=s(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-toxaei"&&(B.innerHTML=ni),nt=a(e),J=s(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-4rhe4m"&&(J.textContent=oi),ot=a(e),Q=s(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-yg7e4b"&&(Q.textContent=ai),at=a(e),X=s(e,"UL",{"data-svelte-h":!0}),r(X)!=="svelte-1a2fyb0"&&(X.innerHTML=li),lt=a(e),h(Z.$$.fragment,e),st=a(e),Y=s(e,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-1dfzi7r"&&(Y.innerHTML=si),rt=a(e),ee=s(e,"P",{"data-svelte-h":!0}),r(ee)!=="svelte-1rx06j3"&&(ee.innerHTML=ri),ft=a(e),te=s(e,"P",{"data-svelte-h":!0}),r(te)!=="svelte-1s1umgf"&&(te.innerHTML=fi),ht=a(e),ie=s(e,"P",{"data-svelte-h":!0}),r(ie)!=="svelte-1iki27j"&&(ie.textContent=hi),dt=a(e),ne=s(e,"P",{"data-svelte-h":!0}),r(ne)!=="svelte-yg7e4b"&&(ne.textContent=di),ut=a(e),oe=s(e,"UL",{"data-svelte-h":!0}),r(oe)!=="svelte-13xi2p"&&(oe.innerHTML=ui),mt=a(e),h(ae.$$.fragment,e),pt=a(e),le=s(e,"P",{"data-svelte-h":!0}),r(le)!=="svelte-g7q4no"&&(le.innerHTML=mi),gt=a(e),se=s(e,"P",{"data-svelte-h":!0}),r(se)!=="svelte-d64uny"&&(se.innerHTML=pi),ct=a(e),re=s(e,"P",{"data-svelte-h":!0}),r(re)!=="svelte-1alio4b"&&(re.innerHTML=gi),vt=a(e),fe=s(e,"P",{"data-svelte-h":!0}),r(fe)!=="svelte-1ua1x4z"&&(fe.innerHTML=ci),wt=a(e),he=s(e,"P",{"data-svelte-h":!0}),r(he)!=="svelte-k2bp8k"&&(he.innerHTML=vi),bt=a(e),de=s(e,"P",{"data-svelte-h":!0}),r(de)!=="svelte-fuga1u"&&(de.innerHTML=wi),xt=a(e),ue=s(e,"P",{"data-svelte-h":!0}),r(ue)!=="svelte-4ou9mw"&&(ue.textContent=bi),Tt=a(e),me=s(e,"P",{"data-svelte-h":!0}),r(me)!=="svelte-ss4u7x"&&(me.textContent=xi),Mt=a(e),pe=s(e,"UL",{"data-svelte-h":!0}),r(pe)!=="svelte-19km321"&&(pe.innerHTML=Ti),Ct=a(e),h(ge.$$.fragment,e),yt=a(e),ce=s(e,"TABLE",{"data-svelte-h":!0}),r(ce)!=="svelte-1c8l148"&&(ce.innerHTML=Mi),Lt=a(e),ve=s(e,"P",{"data-svelte-h":!0}),r(ve)!=="svelte-1qdw6mh"&&(ve.textContent=Ci),$t=a(e),we=s(e,"UL",{"data-svelte-h":!0}),r(we)!=="svelte-19tvw5i"&&(we.innerHTML=yi),_t=a(e),h(be.$$.fragment,e),kt=a(e),xe=s(e,"P",{"data-svelte-h":!0}),r(xe)!=="svelte-qo9jmr"&&(xe.innerHTML=Li),Dt=a(e),h(Te.$$.fragment,e),Ht=a(e),Ce=s(e,"P",{}),$i(Ce).forEach(i),this.h()},h(){_i(c,"name","hf:doc:metadata"),_i(c,"content",Ni)},m(e,t){Ai(document.head,c),n(e,ye,t),n(e,Me,t),n(e,Le,t),d(v,e,t),n(e,$e,t),n(e,w,t),n(e,_e,t),d(b,e,t),n(e,ke,t),n(e,x,t),n(e,De,t),n(e,T,t),n(e,He,t),n(e,M,t),n(e,Ie,t),d(C,e,t),n(e,Pe,t),n(e,y,t),n(e,Ee,t),d(L,e,t),n(e,Ae,t),n(e,$,t),n(e,Se,t),n(e,_,t),n(e,Ge,t),n(e,k,t),n(e,Ne,t),n(e,D,t),n(e,Ue,t),n(e,H,t),n(e,qe,t),n(e,I,t),n(e,Oe,t),n(e,P,t),n(e,Re,t),d(E,e,t),n(e,Fe,t),n(e,A,t),n(e,je,t),n(e,S,t),n(e,Ve,t),n(e,G,t),n(e,We,t),n(e,N,t),n(e,Ke,t),n(e,U,t),n(e,ze,t),n(e,q,t),n(e,Be,t),d(O,e,t),n(e,Je,t),n(e,R,t),n(e,Qe,t),n(e,F,t),n(e,Xe,t),n(e,j,t),n(e,Ze,t),n(e,V,t),n(e,Ye,t),n(e,W,t),n(e,et,t),n(e,K,t),n(e,tt,t),d(z,e,t),n(e,it,t),n(e,B,t),n(e,nt,t),n(e,J,t),n(e,ot,t),n(e,Q,t),n(e,at,t),n(e,X,t),n(e,lt,t),d(Z,e,t),n(e,st,t),n(e,Y,t),n(e,rt,t),n(e,ee,t),n(e,ft,t),n(e,te,t),n(e,ht,t),n(e,ie,t),n(e,dt,t),n(e,ne,t),n(e,ut,t),n(e,oe,t),n(e,mt,t),d(ae,e,t),n(e,pt,t),n(e,le,t),n(e,gt,t),n(e,se,t),n(e,ct,t),n(e,re,t),n(e,vt,t),n(e,fe,t),n(e,wt,t),n(e,he,t),n(e,bt,t),n(e,de,t),n(e,xt,t),n(e,ue,t),n(e,Tt,t),n(e,me,t),n(e,Mt,t),n(e,pe,t),n(e,Ct,t),d(ge,e,t),n(e,yt,t),n(e,ce,t),n(e,Lt,t),n(e,ve,t),n(e,$t,t),n(e,we,t),n(e,_t,t),d(be,e,t),n(e,kt,t),n(e,xe,t),n(e,Dt,t),d(Te,e,t),n(e,Ht,t),n(e,Ce,t),It=!0},p:Di,i(e){It||(u(v.$$.fragment,e),u(b.$$.fragment,e),u(C.$$.fragment,e),u(L.$$.fragment,e),u(E.$$.fragment,e),u(O.$$.fragment,e),u(z.$$.fragment,e),u(Z.$$.fragment,e),u(ae.$$.fragment,e),u(ge.$$.fragment,e),u(be.$$.fragment,e),u(Te.$$.fragment,e),It=!0)},o(e){m(v.$$.fragment,e),m(b.$$.fragment,e),m(C.$$.fragment,e),m(L.$$.fragment,e),m(E.$$.fragment,e),m(O.$$.fragment,e),m(z.$$.fragment,e),m(Z.$$.fragment,e),m(ae.$$.fragment,e),m(ge.$$.fragment,e),m(be.$$.fragment,e),m(Te.$$.fragment,e),It=!1},d(e){e&&(i(ye),i(Me),i(Le),i($e),i(w),i(_e),i(ke),i(x),i(De),i(T),i(He),i(M),i(Ie),i(Pe),i(y),i(Ee),i(Ae),i($),i(Se),i(_),i(Ge),i(k),i(Ne),i(D),i(Ue),i(H),i(qe),i(I),i(Oe),i(P),i(Re),i(Fe),i(A),i(je),i(S),i(Ve),i(G),i(We),i(N),i(Ke),i(U),i(ze),i(q),i(Be),i(Je),i(R),i(Qe),i(F),i(Xe),i(j),i(Ze),i(V),i(Ye),i(W),i(et),i(K),i(tt),i(it),i(B),i(nt),i(J),i(ot),i(Q),i(at),i(X),i(lt),i(st),i(Y),i(rt),i(ee),i(ft),i(te),i(ht),i(ie),i(dt),i(ne),i(ut),i(oe),i(mt),i(pt),i(le),i(gt),i(se),i(ct),i(re),i(vt),i(fe),i(wt),i(he),i(bt),i(de),i(xt),i(ue),i(Tt),i(me),i(Mt),i(pe),i(Ct),i(yt),i(ce),i(Lt),i(ve),i($t),i(we),i(_t),i(kt),i(xe),i(Dt),i(Ht),i(Ce)),i(c),p(v,e),p(b,e),p(C,e),p(L,e),p(E,e),p(O,e),p(z,e),p(Z,e),p(ae,e),p(ge,e),p(be,e),p(Te,e)}}}const Ni='{"title":"Unit 4: Going Further with Diffusion Models","local":"unit-4-going-further-with-diffusion-models","sections":[{"title":"Start this Unit :rocket:","local":"start-this-unit-rocket","sections":[],"depth":2},{"title":"Table of Contents","local":"table-of-contents","sections":[],"depth":2},{"title":"Faster Sampling via Distillation","local":"faster-sampling-via-distillation","sections":[],"depth":2},{"title":"Training Improvements","local":"training-improvements","sections":[],"depth":2},{"title":"More Control for Generation and Editing","local":"more-control-for-generation-and-editing","sections":[],"depth":2},{"title":"Video","local":"video","sections":[],"depth":2},{"title":"Audio","local":"audio","sections":[],"depth":2},{"title":"New Architectures and Approaches - Towards ‘Iterative Refinement’","local":"new-architectures-and-approaches---towards-iterative-refinement","sections":[],"depth":2},{"title":"Hands-On Notebooks","local":"hands-on-notebooks","sections":[],"depth":2},{"title":"Where Next?","local":"where-next","sections":[],"depth":2}],"depth":1}';function Ui(Pt){return Hi(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fi extends Ii{constructor(c){super(),Pi(this,c,Ui,Gi,ki,{})}}export{Fi as component};
